package com.hisschemoller.utils 
{
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 6, 2011
	 */
	public class EuclidGeneratorOld2
	{
		//private var _tempPattern : Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>( );
		private var _pattern : Vector.<Boolean> = new Vector.<Boolean>( );

		public function EuclidGeneratorOld2 ( total : int, hits : int )
		{
			/** Fill the vector with vectors containing one Boolean. */
			//for( var i : uint = 0; i < total; i++ )
			//{
			//	_tempPattern.push( Vector.<Boolean>( [ i < hits ] ) );
			//}
			
			//bjorkland( total, hits );
			//log( "d _pattern.length: " + _pattern.length );
			_pattern = Vector.<Boolean>( eugen( total, hits ) );
			
			log( "d eugen: " + _pattern );
		}

		public function get pattern () : Vector.<Boolean>
		{
			return _pattern;
		}

		/**
		 * 
		 */
		//		private function bjorkland ( total : int, hits : int ) : int
		//		{
		//			log( "i Pattern: " + getPatternString( _tempPattern ) + ", hits: " + hits + ", total: " + total + " (start)" );
		//			
		//			if( hits == 0 )
		//			{
		//				/** Create flattened version of the 2-dimensional vector. */
		//				var n : uint = _tempPattern.length;
		//				for( var i : uint = 0; i < n; i++ )
		//				{
		//					_pattern = _pattern.concat( _tempPattern[ i ] );
		//				}
		//				_tempPattern = null;
		//				
		//				/** Done. */
		//				return total;
		//			}
		//			else if( hits == 1 )
		//			{
		//				/** Return, because there's no need to move the last vector. */
		//				return bjorkland( hits, total % hits );
		//			}
		//			
		//			/**  */
		//			var empties : uint = total - hits;
		//			
		//			if( empties >= hits )
		//			{
		//				var moves : uint = hits;
		//				var itemsPerMove : int = Math.floor( empties / hits );
		//			}
		//			else
		//			{
		//				moves = empties;
		//				itemsPerMove = Math.floor( ( hits - empties ) / empties );
		//			}
		//			
		//			for( i = 0; i < moves; i++ )
		//			{
		//				for( var j : uint = 0; j < itemsPerMove; j++ )
		//				{
		//					_tempPattern[ i ] = _tempPattern[ i ].concat( _tempPattern.pop( ) );
		//				}
		//			}
		//			
		//			log( "i Pattern: " + getPatternString( _tempPattern ) + ", hits: " + hits + ", total: " + total + ", moves: " + moves + ", items per move: " + itemsPerMove + " (end)" );
		//			return bjorkland( hits, total % hits );
		//		}
		private function getPatternString ( pattern : Vector.<Vector.<Boolean>> ) : String
		{
			var patternString : String = "";
			var n : uint = pattern.length;
			for( var i : uint = 0; i < n; i++)
			{
				var m : uint = pattern[i].length;
				for( var j : uint = 0; j < m; j++)
				{
					patternString += ( pattern[ i ][ j ] ) ? "x" : ".";
				}
			}
			
			return patternString;
		}

		private function eugen (total : int, hits : int) : Array
		{
			var r : Array = new Array( );
			if (hits >= total || total == 1 || hits == 0) 
			{ 
				//test for input for sanity
				if (hits >= total) 
				{
					for (var i : uint = 0; i < total; i++) 
					{ 
						//give trivial rhythm of a pulse on every step
						r.push( 1 );
					}
				} 
				else if (total == 1) 
				{
					if (hits == 1) 
					{
						r.push( 1 );
					} 
					else 
					{
						r.push( 0 );
					}
				} 
				else 
				{
					for (i = 0; i < total; i++) 
					{
						r.push( 0 );
					}
				}
			} 
			else 
			{ 
				//sane input
				var pauses : int = total - hits;
				if (pauses >= hits) 
				{ 
					//first case more pauses than p
					var per_pulse : int = Math.floor( pauses / hits );
					var remainder : int = pauses % hits;
					for (i = 0; i < hits; i++) 
					{
						r.push( 1 );
						for (var j : uint = 0; j < per_pulse; j++) 
						{
							r.push( 0 );
						}
						if (i < remainder) 
						{
							r.push( 0 );
						}
					}
				} 
				else 
				{ 
					//second case more p than pauses
					var per_pause : int = Math.floor( (hits - pauses) / pauses );
					remainder = (hits - pauses) % pauses;
					for (i = 0; i < pauses; i++) 
					{
						r.push( 1 );
						r.push( 0 );
						for (j = 0; j < per_pause; j++) 
						{
							r.push( 1 );
						}
						if (i < remainder) 
						{
							r.push( 1 );
						}
					}
				}
			}
			
			for(i = 0; i < r.length; i++)
			{
				r[i] = (r[i] == 1);
			}
			
			return r;
		}
	}
}
